#! /usr/bin/env python
__doc__ = """\
Project:    rPAS 
Version:    $Id: python.prov.py 2 2005-01-10 15:19:27Z cray $
Licence:    GPL
Start:      Mon Mar 15 00:52:16 MSK 2004
Title:      RPM Build Python  / Find Provides
Author:     
    Andrey Orlov (c) 2004
        
Description:     

    This application is intendent to extract provides for python packages.
    
Call:
    python_provides.py [<MODULE>]+

Switches:

    None

Warranty:

    There is no warranty of any kind, either expressed
    or implied
                        
TODO:
    Nothing

"""
from __future__ import generators
__version__ = '$Revision: 1.1 $'[10:-1]
# $Id: python.prov.py 2 2005-01-10 15:19:27Z cray $
def _(s) : return s

try :
    import sys, os
except :
    pass
else :    
    prefix = "python%u.%u" % sys.version_info[0:2]

    files = sys.argv[1:] or [ x.strip() for x in sys.stdin.readlines() ] 
    
    path = []
    for item in [ [x for x in [ x.strip() for x in open(x).readlines() ] if x] for x in files if os.path.splitext(x) == ".pth" and os.path.dirname(x) == os.path.join('usr','lib',prefix,'site-packages') ] :
        path.extend(item)

    path = tuple(sys.path[1:])+tuple(os.getenv('RPM_PYTHON_LIB_PATH','').split()) + tuple(path)

    pl = [] 
    buildroot = os.getenv('RPM_BUILD_ROOT',"")
    init_d = dict(
        [(x,None) for x,y in [ os.path.split(x) for x in files ] if y == '__init__.py']
        + [ (os.path.normpath(buildroot + "/" + x),None) for x in os.getenv('RPM_PYTHON_MODULE_DECLARED','').split() ]
    )

    for module in os.getenv('RPM_PYTHON_MODULE_DECLARED','').split() :
        module = [ x for x in module.split("/") if x]
        for item in path :
            item = [ x for x in item.split("/") if x]
            if item == module[0:len(item)] :
                root = os.path.normpath(buildroot + "/" + os.path.join(*item))
                for parent in module[len(item):] :
                    root = os.path.join(root,parent)
                    if not init_d.has_key(root) :
                        break
                else :
                    pl.append( ( (".".join(module[len(item):]),) ,os.path.join(* ["/",buildroot]+module) ))

    path = [os.path.normpath(os.path.join( buildroot or '/', './'+x)) for x in path  ]

    sd = {}
    
    for src in files :
        if os.path.normpath(os.path.dirname(src)) in path :
            m,e = os.path.splitext( os.path.basename(src))
            if not '/' in m :
                print "%s(%s)" % (prefix,m)
                if e in ['.so'] :
                    if m[-6:] == "module" :
                        print "%s(%s)" % (prefix,m[0:-6])

        if os.path.basename(src) in ['__init__.py'] :
            if os.path.dirname(os.path.dirname(src)) in path :
                pl.append(((os.path.basename(os.path.dirname(src)),), os.path.dirname(src)) )
                print "%s(%s)" % (prefix,os.path.basename(os.path.dirname(src)))

        name,ext = os.path.splitext(os.path.basename(src))
        if ext in [".py"] :
            if name != "__init__":
                sd.setdefault(os.path.dirname(src),[]).append(name)
            else :
                sd.setdefault(os.path.dirname(os.path.dirname(src)),[]).append(os.path.basename(os.path.dirname(src)))


    while pl :
        m,p = pl.pop()

        try :
            pis = sd[p]
        except KeyError :
            pass
        else :
            for pi in pis :
                mo = m+(pi,)
                print "%s(%s)" % (prefix,".".join(mo))
                pl.insert(0,(mo, os.path.join(p,pi)))
